/*******************************************************************************
*            Programme de commande Sepcsmaster                                 *
*            d'aprs ManufacturingTest (PLX Technology)                        *
*                                                                              *
*       Cration : 7 juillet 2003                                              *
*                  C.Pailler               LAL Orsay                           *
 ******************************************************************************/

// ManfGUIDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ManfGUI.h"
#include "ManfGUIDlg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

SPECS_API int modI2C;
SPECS_API int modJTAG;
SPECS_API int modParallelBus;
SPECS_API int modRegistre;

/***************Global variables*****************/     
BOOL            EnableAll;  
BOOL            ClearAll;
BOOL            EnablePci;  
BOOL            EnableIop;
BOOL            BoardIn;
BOOL            AbortTest = FALSE;
BOOL            Failed = FALSE; 

HANDLE          PlxHandle;
DEVICE_LIST     CurrentDeviceList[MAX_PCI_DEV];
BSP             DeviceBsp;
CHAR            LogFileName[15];
CHAR            Buffer[80];
U32             loop;
U32             TimerCheck;
U32             DevIndex;
U32				CurrentTotalDeviceNum;
//DEVICE_LOCATION CPci9054device;
//REGISTEROFFSET  RegisterOffset;
CString			lpFenetreEdit1 = _T("");
VIRTUAL_ADDRESSES Va;
U32				BufferSrc[0x100];
U8				AddI2c;
DWORD		dwMilliseconds = 100;
SPECSMASTER		pSpm1[4], pSpm2[4], pSpm3[4], pSpm4[4];
SPECSSLAVE		pSlv1[1];
HANDLE			pHdle[4];
U32				Index;
CString			strNomDeFichier = _T("");
/************************************************/

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CManfGUIDlg dialog

CManfGUIDlg::CManfGUIDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CManfGUIDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CManfGUIDlg)
	m_PomCheck = FALSE;
	m_LoopCount = 0.0;
	m_DeviceString = _T("");
	m_strRichEdit0 = _T("");
	m_NombrelmotsEdit = 1;
	m_DureeBoucle = 100;
	m_strI2cEdit = _T("");
	m_strLectfifoEdit = _T("");
	m_strEcrCtrl = _T("");
	m_LectI2cBytecnt = 3;
	m_strJtagEdit = _T("");
	m_strParallelData = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CManfGUIDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CManfGUIDlg)
	DDX_Control(pDX, IDC_RICHEDIT0, m_ctrRichEdit0);
	DDX_Control(pDX, IDC_LOOPCOUNT_SPIN, m_Spin);
	DDX_Check(pDX, IDC_POM_CHECK, m_PomCheck);
	DDX_Text(pDX, IDC_LOOPCOUNT_EDIT, m_LoopCount);
	DDV_MinMaxDouble(pDX, m_LoopCount, 1., 1000000.);
	DDX_CBString(pDX, IDC_DEVICE_COMBO, m_DeviceString);
	DDX_Text(pDX, IDC_RICHEDIT0, m_strRichEdit0);
	DDV_MaxChars(pDX, m_strRichEdit0, 2048);
	DDX_Text(pDX, IDC_NOMBRELMOTS_EDIT, m_NombrelmotsEdit);
	DDV_MinMaxInt(pDX, m_NombrelmotsEdit, 1, 256);
	DDX_Text(pDX, IDC_DUREEBOUCLE_EDIT, m_DureeBoucle);
	DDV_MinMaxDWord(pDX, m_DureeBoucle, 1, 5000);
	DDX_Text(pDX, IDC_I2C_EDIT, m_strI2cEdit);
	DDX_Text(pDX, IDC_LECTFIFO_EDIT, m_strLectfifoEdit);
	DDX_Text(pDX, IDC_ECRCTRL_EDIT, m_strEcrCtrl);
	DDV_MaxChars(pDX, m_strEcrCtrl, 2);
	DDX_Text(pDX, IDC_LECTI2CBYTECNT_EDIT, m_LectI2cBytecnt);
	DDX_Text(pDX, IDC_JTAG_EDIT, m_strJtagEdit);
	DDX_Text(pDX, IDC_PARALLELWRITE_EDIT, m_strParallelData);
	DDV_MaxChars(pDX, m_strParallelData, 8);
	//}}AFX_DATA_MAP

}

BEGIN_MESSAGE_MAP(CManfGUIDlg, CDialog)
	//{{AFX_MSG_MAP(CManfGUIDlg)
	ON_BN_CLICKED(IDC_STARTEST_BUTTON, OnStartestButton)
	ON_CBN_CLOSEUP(IDC_DEVICE_COMBO, OnOpenDevice)
	ON_BN_CLICKED(IDC_STOP_BUTTON, OnStopButton)
	ON_BN_DOUBLECLICKED(IDC_STOP_BUTTON, OnDoubleclickedStopButton)
	ON_BN_CLICKED(IDC_BOARD_CONFIG_BUTTON, OnBoardConfigButton)
	ON_EN_CHANGE(IDC_RICHEDIT0, OnChangeRichedit0)
	ON_EN_CHANGE(IDC_NOMBRELMOTS_EDIT, OnChangeNombrelmotsEdit)
	ON_BN_CLICKED(IDC_COPIETEXT_BUTTON, OnCopietextButton)
	ON_BN_CLICKED(IDC_COLLERTEXT_BUTTON, OnCollertextButton)
	ON_BN_CLICKED(IDC_POM_CHECK, OnPomCheck)
	ON_BN_CLICKED(IDC_DETAILS_BUTTON, OnDetailsButton)
	ON_EN_CHANGE(IDC_DUREEBOUCLE_EDIT, OnChangeDureeboucleEdit)
	ON_EN_CHANGE(IDC_I2C_EDIT, OnChangeI2cEdit)
	ON_BN_CLICKED(IDC_COPI2CSPEC_BUTTON, OnCopi2cspecButton)
	ON_BN_CLICKED(IDC_LECTFIFO_BUTTON, OnLectfifoButton)
	ON_BN_CLICKED(IDC_LECTSTATUS_BUTTON, OnLectstatusButton)
	ON_EN_CHANGE(IDC_ECRCTRL_EDIT, OnChangeEcrctrlEdit)
	ON_BN_CLICKED(IDC_ECRCTRL_BUTTON, OnEcrctrlButton)
	ON_EN_CHANGE(IDC_LECTI2CBYTECNT_EDIT, OnChangeLecti2cbytecntEdit)
	ON_BN_CLICKED(IDC_LECTI2C_BUTTON, OnLecti2cButton)
	ON_BN_CLICKED(IDC_I2CWRITE_BUTTON, OnI2cwriteButton)
	ON_BN_CLICKED(IDC_TDIWRITE_BUTTON, OnTdiwriteButton)
	ON_BN_CLICKED(IDC_TDITOSPECS_BUTTON, OnTditospecsButton)
	ON_BN_CLICKED(IDC_TMSTOSPECS_BUTTON, OnTmstospecsButton)
	ON_BN_CLICKED(IDC_TMSWRITE_BUTTON, OnTmswriteButton)
	ON_EN_CHANGE(IDC_JTAG_EDIT, OnChangeJtagEdit)
	ON_BN_CLICKED(IDC_OPENFILE_BUTTON, OnOpenfileButton)
	ON_BN_CLICKED(IDC_SAVEFILE_BUTTON, OnSavefileButton)
	ON_EN_CHANGE(IDC_PARALLELWRITE_EDIT, OnChangeParallelwriteEdit)
	ON_BN_CLICKED(IDC_PARALLELWRITE_BUTTON, OnParallelwriteButton)
	ON_BN_CLICKED(IDC_W0_BUTTON, OnW0Button)
	ON_BN_CLICKED(IDC_W1_BUTTON, OnW1Button)
	ON_BN_CLICKED(IDC_W2_BUTTON, OnW2Button)
	ON_BN_CLICKED(IDC_W3_BUTTON, OnW3Button)
	ON_BN_CLICKED(IDC_W4_BUTTON, OnW4Button)
	ON_BN_CLICKED(IDC_W5_BUTTON, OnW5Button)
	ON_BN_CLICKED(IDC_PARALLELREAD_BUTTON, OnParallelreadButton)
	ON_BN_CLICKED(IDC_R0_BUTTON, OnR0Button)
	ON_BN_CLICKED(IDC_R1_BUTTON, OnR1Button)
	ON_BN_CLICKED(IDC_R2_BUTTON, OnR2Button)
	ON_BN_CLICKED(IDC_R3_BUTTON, OnR3Button)
	ON_BN_CLICKED(IDC_R4_BUTTON, OnR4Button)
	ON_BN_CLICKED(IDC_R5_BUTTON, OnR5Button)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CManfGUIDlg message handlers

BOOL CManfGUIDlg::OnInitDialog()
{
	FILE *stream;
	int fh1, fh2, Taille, j, tailleBufI2c;
	unsigned char BufI2c[50];
	char chTab[2048];

	CDialog::OnInitDialog();

	m_ctrRichEdit0.SetEventMask(m_ctrRichEdit0.GetEventMask() | ENM_CHANGE);

    //Print the dialog title
    sprintf(Buffer, "Specs");
    SetWindowText(Buffer);

    ButtonInitialization();

    //Find all plx devices and list them in combo list box.
    CComboBox * pCombo = (CComboBox *)GetDlgItem(IDC_DEVICE_COMBO);
    CButton * pDetailsButton = (CButton*)GetDlgItem(IDC_DETAILS_BUTTON);

    DevIndex = SelectDevice(&PlxHandle, CurrentDeviceList);
    if (DevIndex == 0)
    {
        m_DeviceString = "No Specsmaster board found.";
        pDetailsButton->SetWindowText(m_DeviceString);
        //Disable the GUI window.
        UpdateData(FALSE);
        GuiDisable();
        return TRUE;
    }
    else
    {
        for (UINT i=0; i<DevIndex; i++)
        {
            m_DeviceString = CurrentDeviceList[i].DevStr;
            pCombo->AddString(m_DeviceString);
        }
		UpdateData(FALSE);
    }

 
    UpdateData(TRUE);

    for (UINT i=0; i<DevIndex; i++)
    {
            DeviceBsp.device.VendorId   = CurrentDeviceList[i].device.VendorId;
            DeviceBsp.device.DeviceId   = CurrentDeviceList[i].device.DeviceId;
            DeviceBsp.device.BusNumber  = CurrentDeviceList[i].device.BusNumber;
            DeviceBsp.device.SlotNumber = CurrentDeviceList[i].device.SlotNumber;
            strcpy((char*)DeviceBsp.device.SerialNumber, "");
            
            if (PlxPciDeviceOpen(&DeviceBsp.device, &PlxHandle) == ApiSuccess)
            {
				if ((DeviceBsp.device.DeviceId == PLX_9030_DEVICE_ID) &&
					(DeviceBsp.device.VendorId == PLX_VENDOR_ID))
				{
					pDetailsButton->SetWindowText("Specsmaster board opened (Reset button)");
                    UpdateData(FALSE);
				}
				pHdle[i] = PlxHandle;

//				ancien2ecr();

				SpecsmasterInit(&pSpm1[i],1,PlxHandle);
				SpecsmasterInit(&pSpm2[i],2,PlxHandle);
				SpecsmasterInit(&pSpm3[i],3,PlxHandle);
				SpecsmasterInit(&pSpm4[i],4,PlxHandle);

				SpecsmasterReset(&pSpm1[i]);
            }
	}

	if( (stream  = fopen( "plx-i2c.txt", "r" )) == NULL )
	{
		AfxMessageBox("TestDirectSlave : pas de plx-i2c.txt", MB_OK | MB_ICONEXCLAMATION);
		exit( 1 );
	}

	fh1 = 0 ;
	while ( (fscanf( stream, "%x", &BufI2c[fh1])) != EOF)
	{
		fh1++ ;
	}
	tailleBufI2c = fh1;
	AddI2c = BufI2c[0] >> 1;


	if( fclose( stream ) )
	{
		AfxMessageBox("cloture ratee", MB_OK | MB_ICONEXCLAMATION);
		exit( 1 );
	}


	fh2 = 0;
	while (fh2 < 2048)
	{
		chTab[fh2] = NULL;
		fh2++ ;
	}

	Taille = tailleBufI2c;
	j = 0;
	fh2 = 0;
	while ( j < Taille )
	{
		fh2 +=sprintf( chTab+fh2,"%.2X\r\n",BufI2c[j] );
		j++;
	}
	
	chTab[fh2-1] = NULL;
	chTab[fh2-2] = NULL;

	m_strI2cEdit = chTab;

	m_NombrelmotsEdit = I2ctoSpecs(BufI2c,BufferSrc,tailleBufI2c);
	BufferSrc[1] = BufferSrc[1] | (tailleBufI2c-1) << 8;
	Taille = m_NombrelmotsEdit;
	j = 0;
	fh2 = 0;
	while ( j < Taille-1 )
	{
		fh2 +=sprintf( chTab+fh2,"%.8X\r\n",BufferSrc[j] );
		j++;
	}
	fh2 +=sprintf( chTab+fh2,"%.8X",BufferSrc[j] );

	m_strRichEdit0 = chTab;

	UpdateData(FALSE);

    OnOpenDevice();


//    OnEnableallButton();
  
    UpdateData(FALSE);

	return TRUE;  // return TRUE unless you set the focus to a control
}


void CManfGUIDlg::OnStartestButton() 
{
 
//  RETURN_CODE  rc;
  BOOL         IopReset = FALSE;
//  char         buf[10];


//  ancien2ecr();

  // Get data from Dlg
  UpdateData(TRUE);

  if (AbortTest == TRUE)
  {
      loop = 1;
      AbortTest = FALSE;  
  }


  GetDlgItem(IDC_STARTEST_BUTTON)->EnableWindow(FALSE);
  GetDlgItem(IDC_STOP_BUTTON)->EnableWindow(TRUE);

  CButton * pDetailsButton = (CButton *)GetDlgItem(IDC_DETAILS_BUTTON);  

    sprintf(Buffer, "Reset");
    pDetailsButton->SetWindowText(Buffer);
    UpdateData(FALSE);

    for (loop = 1; loop <= m_LoopCount; loop++)
    {
/*        if (DoLog)
        LogWriteSection(loop);*/
		if (m_PomCheck)
			PlxPciBoardReset (pHdle[Index]);

	    //Display the current loop number.
	    _itoa(loop, Buffer, 10);
	    CButton * pCurrentLoopButton = (CButton *)GetDlgItem(IDC_CURRENTLOOP_BUTTON);  
	    pCurrentLoopButton->SetWindowText(Buffer);

	    CheckAbort();
	    if (AbortTest == TRUE)
            return;
      
	    TestDirectSlave(
        PlxHandle,
		Va
        );
    }
   
    //Tests complete
//	_itoa(loop-1, buf, 10);
    sprintf(Buffer, "Cycle completed   (Reset button)");
//	strcat(Buffer, buf);

	GetDlgItem(IDC_STARTEST_BUTTON)->EnableWindow(TRUE);
	GetDlgItem(IDC_STOP_BUTTON)->EnableWindow(FALSE);

    pDetailsButton->SetWindowText(Buffer);
    UpdateData(FALSE);
//    ResetBoard(&DeviceBsp);
}


void CManfGUIDlg::GuiDisable(void)
{
    //Disable all the controls but Exit.
    GetDlgItem(IDC_STARTEST_BUTTON)->EnableWindow(FALSE);
    GetDlgItem(IDC_STOP_BUTTON)->EnableWindow(FALSE);
    GetDlgItem(IDC_LOOPCOUNT_SPIN)->EnableWindow(FALSE);
    GetDlgItem(IDC_LOOPCOUNT_EDIT)->EnableWindow(FALSE);
    GetDlgItem(IDC_LOG_CHECK)->EnableWindow(FALSE);
    GetDlgItem(IDC_LECTFIFO_BUTTON)->EnableWindow(FALSE);

}



void CManfGUIDlg::OnOpenDevice() 
{ 
    UpdateData(TRUE);

//    CComboBox * pCombo = (CComboBox *)GetDlgItem(IDC_DEVICE_COMBO);
//    CButton * pDetailsButton = (CButton*)GetDlgItem(IDC_DETAILS_BUTTON);
    for (UINT i=0; i<DevIndex; i++)
    {
        if (strcmp(CurrentDeviceList[i].DevStr, m_DeviceString)==0)
        {
            DeviceBsp.device.VendorId   = CurrentDeviceList[i].device.VendorId;
            DeviceBsp.device.DeviceId   = CurrentDeviceList[i].device.DeviceId;
            DeviceBsp.device.BusNumber  = CurrentDeviceList[i].device.BusNumber;
            DeviceBsp.device.SlotNumber = CurrentDeviceList[i].device.SlotNumber;
            strcpy((char*)DeviceBsp.device.SerialNumber, "");

			Index = i;
            
        }
    }

//	ResetButtonText();
    InitializeBsp(&DeviceBsp);
}


void CManfGUIDlg::CheckAbort() 
{
    MSG message;


    if (::PeekMessage(&message, NULL, 0,  0, PM_REMOVE))
    {
        ::TranslateMessage(&message);
        ::DispatchMessage(&message);
    }
}




void CManfGUIDlg::OnStopButton() 
{
	char buf[30];

    
	CButton * pDetailsButton = (CButton *)GetDlgItem(IDC_DETAILS_BUTTON); 
    AbortTest = TRUE;
    
	_itoa(loop-1, buf, 10);
	sprintf(Buffer, "Interrupt : ");
	strcat(Buffer, buf);
	
	if(Failed == TRUE)
	{
		sprintf(buf, "    Failed.");
        strcat(Buffer, buf);
	}
	else
	{
		sprintf(buf, " loop(s) completed.");
        strcat(Buffer, buf);
	}

    pDetailsButton->SetWindowText(Buffer);

	GetDlgItem(IDC_STARTEST_BUTTON)->EnableWindow(TRUE);
	GetDlgItem(IDC_STOP_BUTTON)->EnableWindow(FALSE);
}




void CManfGUIDlg::OnDoubleclickedStopButton()
{
	char buf[10];


	CButton * pDetailsButton = (CButton *)GetDlgItem(IDC_DETAILS_BUTTON); 
    AbortTest = TRUE;

	_itoa(loop-1, buf, 10);
    sprintf(Buffer, "Test aborted.  Loop# ");
	strcat(Buffer, buf);
    
	if(Failed == TRUE)
	{
		sprintf(buf, "    Failed.");
        strcat(Buffer, buf);
	}
	else
	{
		sprintf(buf, "    Passed.");
        strcat(Buffer, buf);
	}

    pDetailsButton->SetWindowText(Buffer);
}




void CManfGUIDlg::OnBoardConfigButton()
{
	m_dlg.DoModal();
}


void CManfGUIDlg::ButtonInitialization()
{
    //Set loop counter
    m_LoopCount = 1;
    CSpinButtonCtrl* pSpin = (CSpinButtonCtrl*)GetDlgItem(IDC_LOOPCOUNT_SPIN);
    pSpin->SetRange(1, 1000000);
    
    //Set log to file
//    m_LogCheck = FALSE;
}


/*void CManfGUIDlg::ancien2ecr()
{
    RETURN_CODE     rc;
//	VIRTUAL_ADDRESSES Va;

	/************************************
	*        recherche des adresses
	*            virtuelles
	*************************************
	rc = PlxPciBaseAddressesGet(
			PlxHandle,
			&Va
			);

    /************************************
    *        Perform the Test
    ************************************
    TestDirectSlave(
        PlxHandle,
		Va
        );*
	return;

}*/


void CManfGUIDlg::TestDirectSlave(
    HANDLE PHdle,
	VIRTUAL_ADDRESSES Va
    )
{
	U32			Taille;

	Taille = m_NombrelmotsEdit;

	Sleep(dwMilliseconds);

	SpecsmasterEmitterFIFOWrite(&pSpm1[Index],BufferSrc,Taille);

	return;
}

void CManfGUIDlg::OnChangeRichedit0() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here

	int i=0,j=0,k=0,fh2=0;
	char chTab[2048];
	char chTab1[80];

	while (fh2 < 2048)
	{
		chTab[fh2] = NULL;
		fh2++ ;
	}

	fh2 = 0;
	while (fh2 < 80)
	{
		chTab1[fh2] = NULL;
		fh2++ ;
	}

	fh2 = 0;
	while (fh2 < 256)
	{
		BufferSrc[fh2] = 0;
		fh2++ ;
	}

	UpdateData(TRUE);
	sprintf(chTab,m_strRichEdit0);
//	AfxMessageBox(chTab, MB_OK | MB_ICONEXCLAMATION);

//	strcat(chTab1,chTab);

	while (chTab[i] != NULL)
	{
		while (chTab[i] != '\n' && chTab[i] != NULL)
		{
			chTab1[j] = chTab[i];
			i++;
			j++;
		}

		sscanf(chTab1, "%x", &BufferSrc[k]);
		j = 0;
		i++;
		k++;
		
//		strcat(chTab1,chTab);

//		AfxMessageBox(chTab1, MB_OK | MB_ICONEXCLAMATION);
		fh2 = 0;
		while (fh2 < 80)
		{
			chTab1[fh2] = NULL;
			fh2++ ;
		}
	}
	m_NombrelmotsEdit = k;
	UpdateData(FALSE);
}

void CManfGUIDlg::OnChangeNombrelmotsEdit() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here

	CEdit * pDetailsEdit = (CEdit*)GetDlgItem(IDC_NOMBRELMOTS_EDIT);
	pDetailsEdit->GetWindowText(lpFenetreEdit1);
//	sprintf(Buffer,"%s", lpFenetreEdit1);
//	AfxMessageBox(lpFenetreEdit1, MB_OK | MB_ICONEXCLAMATION);
	if (lpFenetreEdit1 == "")
		return;
	UpdateData(TRUE);
}

void CManfGUIDlg::OnCopietextButton() 
{
	// TODO: Add your control notification handler code here
	m_ctrRichEdit0.Copy();
}

void CManfGUIDlg::OnCollertextButton() 
{
	// TODO: Add your control notification handler code here
	m_ctrRichEdit0.Paste();
}

void CManfGUIDlg::OnPomCheck() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);

}

void CManfGUIDlg::OnDetailsButton() 
{
	// TODO: Add your control notification handler code here
	PlxPciBoardReset (pHdle[Index]);
}

void CManfGUIDlg::OnOK() 
{
	// TODO: Add extra validation here
	
	CDialog::OnOK();
	OnStopButton();
}

void CManfGUIDlg::OnChangeDureeboucleEdit() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	dwMilliseconds = m_DureeBoucle;
}

void CManfGUIDlg::OnChangeI2cEdit() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	int i=0,j=0,k=0,fh2=0;
	char chTab[2048];
	char chTab1[80];
	unsigned char BufI2c[50];

	while (fh2 < 50)
	{
		BufI2c[fh2] = NULL;
		fh2++ ;
	}

	fh2 = 0;
	while (fh2 < 2048)
	{
		chTab[fh2] = NULL;
		fh2++ ;
	}

	fh2 = 0;
	while (fh2 < 80)
	{
		chTab1[fh2] = NULL;
		fh2++ ;
	}
	
	UpdateData(TRUE);
	sprintf(chTab,m_strI2cEdit);
	
	while (chTab[i] != NULL && chTab[i] != '\r')
	{
		while (chTab[i] != '\n' && chTab[i] != NULL)
		{
			chTab1[j] = chTab[i];
			i++;
			j++;
		}

		sscanf(chTab1, "%x", &BufI2c[k]);
		j=0;
		i++;
		k++;
	}

	AddI2c = BufI2c[0] >> 1;

}

void CManfGUIDlg::OnCopi2cspecButton() 
{
	// TODO: Add your control notification handler code here
	int i=0, j=0, k=0, fh2=0, Taille, tailleBufI2c;
	char chTab[2048];
	char chTab1[80];
	unsigned char BufI2c[50];

	UpdateData(TRUE);


	while (fh2 < 50)
	{
		BufI2c[fh2] = NULL;
		fh2++ ;
	}

	fh2 = 0;
	while (fh2 < 2048)
	{
		chTab[fh2] = NULL;
		fh2++ ;
	}

	fh2 = 0;
	while (fh2 < 80)
	{
		chTab1[fh2] = NULL;
		fh2++ ;
	}

	fh2 = 0;
	while (fh2 < 256)
	{
		BufferSrc[fh2] = 0;
		fh2++ ;
	}



	sprintf(chTab,m_strI2cEdit);

	while (chTab[i] != NULL && chTab[i] != '\r')
	{
		while (chTab[i] != '\n' && chTab[i] != NULL)
		{
			chTab1[j] = chTab[i];
			i++;
			j++;
		}

		sscanf(chTab1, "%x", &BufI2c[k]);
		j=0;
		i++;
		k++;
	}
		tailleBufI2c = k;
		AddI2c = BufI2c[0] >> 1;

		m_NombrelmotsEdit = I2ctoSpecs(BufI2c,BufferSrc,tailleBufI2c);

//		m_NombrelmotsEdit = TditoSpecs(BufI2c,BufferSrc,tailleBufI2c);

		BufferSrc[1] = BufferSrc[1] | (tailleBufI2c-1) << 8;

//		BufferSrc[1] = BufferSrc[1] | (tailleBufI2c) << 8;
//		BufferSrc[1] = BufferSrc[1] | 0x10000;
		Taille = m_NombrelmotsEdit;
		j = 0;
		fh2 = 0;
		while ( j < Taille-1 )
		{
			fh2 +=sprintf( chTab+fh2,"%.8X\r\n",BufferSrc[j] );
			j++;
		}
		fh2 +=sprintf( chTab+fh2,"%.8X",BufferSrc[j] );

		m_strRichEdit0 = chTab;

	UpdateData(FALSE);
}

void CManfGUIDlg::OnLectfifoButton() 
{
	// TODO: Add your control notification handler code here
//	int j=0,fh2=0, Taille=0x100;
	int j=0,fh2=0;
	int Taille=0x10;
//	U32 LocalAddress;
	U32 BufferDest[16];
	char chTab[2048];

	UpdateData(TRUE);


	while (fh2 < 2048)
	{
		chTab[fh2] = NULL;
		fh2++ ;
	}

//	ancien2ecr();
//	LocalAddress = DeviceBsp.SramBase;

//	BufferDest = (U32*)(Va.Va2 + LocalAddress);

//	BufferDest = pSpm1[Index].pSpecsmasterReceiverFifo;

	SpecsmasterReceiverFIFORead(&pSpm1[Index], BufferDest, Taille);


	fh2 = 0;
	while (j < Taille)
	{
		fh2 += sprintf(chTab + fh2, "%.8X\r\n", BufferDest[j]);
		j++;
	}

	m_strLectfifoEdit = chTab;
	UpdateData(FALSE);
}

void CManfGUIDlg::OnLectstatusButton() 
{
	// TODO: Add your control notification handler code here

	int		fh2=0;
	char	chTab[2048];
	U32			Status;
	
	UpdateData(TRUE);


	while (fh2 < 2048)
	{
		chTab[fh2] = NULL;
		fh2++ ;
	}

	SpecsmasterStatusRead(&pSpm1[Index],&Status);

	sprintf(chTab, "%.2X\r\n", Status);

	m_strLectfifoEdit = chTab;
	UpdateData(FALSE);
}

void CManfGUIDlg::OnChangeEcrctrlEdit() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	
	UpdateData(TRUE);
}

void CManfGUIDlg::OnEcrctrlButton() 
{
	// TODO: Add your control notification handler code here

	U32		Ctrl;
	
	sscanf(m_strEcrCtrl, "%x", &Ctrl);
	SpecsmasterCtrlWrite(&pSpm1[Index],Ctrl);
	
}

void CManfGUIDlg::OnChangeLecti2cbytecntEdit() 
{
	UpdateData(TRUE);
}

void CManfGUIDlg::OnLecti2cButton() 
{
	// TODO: Add your control notification handler code here
	char chTab[2048];
	U32 fh2, j=0, R;

	U32 Taille=0x10;
	U32 BufferDest[16];
	U32	Status, Status1, Status2, Status3;



	fh2 = 0;
	while (fh2 < 256)
	{
		BufferSrc[fh2] = 0;
		fh2++ ;
	}
	fh2 = 0;
	while (fh2 < 2048)
	{
		chTab[fh2] = NULL;
		fh2++ ;
	}


	fh2 = 0;
//	Status = 0xA;
	Status = 0x0;
	Status2 = 0x2;
//	Status = 0x29;
	pSlv1->pSpecsmaster = &pSpm1[Index];
	pSlv1->SpecsslaveAdd = 0x00;
//	I2cBufferRead(pSlv1,0x40,BufI2c,m_LectI2cBytecnt);
	I2cBufferRead(pSlv1,AddI2c,BufferSrc,m_LectI2cBytecnt);

//	while ((Status & 0xA) || !(Status & 0x20))
//	while (Status & 0x2)
//	while (Status & 0x8)
//	while (!(Status & 0x20))
//	while ((Status & 0x8) || !(Status & 0x20))
	while (!(Status & 0x2) && j<100)
	{
		Status1 = Status;
		SpecsmasterStatusRead(&pSpm1[Index],&Status);
		j++;
	}
	while (Status2 & 0x2)
	{
		Status3 = Status2;
		SpecsmasterStatusRead(&pSpm1[Index],&Status2);
		fh2++;
	}

	SpecsmasterReceiverFIFORead(&pSpm1[Index], BufferDest, Taille);

	j = 0;
	fh2 = 0;
	while (j < Taille)
	{
		fh2 += sprintf(chTab + fh2, "%.8X\r\n", BufferDest[j]);
		j++;
	}

	m_strLectfifoEdit = chTab;

	fh2 = 0;
	while (fh2 < 2048)
	{
		chTab[fh2] = NULL;
		fh2++ ;
	}
	j=0;
	fh2=0;
	R = (9*(m_LectI2cBytecnt+1)+2)%4;
	if (R == 0)
		R = (9*(m_LectI2cBytecnt+1)+2)/4 + 2;
	else
		R = (9*(m_LectI2cBytecnt+1)+2)/4 + 3;

	m_NombrelmotsEdit = R;

	while ( j < R-1 )
	{
		fh2 +=sprintf( chTab+fh2,"%.8X\r\n",BufferSrc[j] );
		j++;
	}
	fh2 +=sprintf( chTab+fh2,"%.8X",BufferSrc[j] );
	

		m_strRichEdit0 = chTab;
	UpdateData(FALSE);
}

void CManfGUIDlg::OnI2cwriteButton()
{
	U32 i=0, j=0, k=0, fh2=0, Taille, tailleBI2cWrite;
	char chTab[2048];
	char chTab1[80];
	unsigned char BufI2c[50];
	unsigned char *pBI2cWrite;

	UpdateData(TRUE);


	while (fh2 < 50)
	{
		BufI2c[fh2] = NULL;
		fh2++ ;
	}

	fh2 = 0;
	while (fh2 < 2048)
	{
		chTab[fh2] = NULL;
		fh2++ ;
	}

	fh2 = 0;
	while (fh2 < 80)
	{
		chTab1[fh2] = NULL;
		fh2++ ;
	}

	fh2 = 0;
	while (fh2 < 256)
	{
		BufferSrc[fh2] = 0;
		fh2++ ;
	}



	sprintf(chTab,m_strI2cEdit);

	while (chTab[i] != NULL && chTab[i] != '\r')
	{
		while (chTab[i] != '\n' && chTab[i] != NULL)
		{
			chTab1[j] = chTab[i];
			i++;
			j++;
		}

		sscanf(chTab1, "%x", &BufI2c[k]);
		j=0;
		i++;
		k++;
	}
	tailleBI2cWrite = k-1;
	AddI2c = BufI2c[0] >> 1;
	pBI2cWrite = &BufI2c[1];

	pSlv1->pSpecsmaster = &pSpm1[Index];
	pSlv1->SpecsslaveAdd = 0x00;

	I2cBufferWrite(pSlv1,AddI2c,pBI2cWrite,tailleBI2cWrite);

//	BufI2c[0] = 0x40 << 1 & 0xFE;

		m_NombrelmotsEdit = I2ctoSpecs(BufI2c,BufferSrc,tailleBI2cWrite+1);

		BufferSrc[1] = BufferSrc[1] | (tailleBI2cWrite) << 8;
		BufferSrc[1] = BufferSrc[1] | modI2C;
		Taille = m_NombrelmotsEdit;
		j = 0;
		fh2 = 0;
		while ( j < Taille-1 )
		{
			fh2 +=sprintf( chTab+fh2,"%.8X\r\n",BufferSrc[j] );
			j++;
		}
		fh2 +=sprintf( chTab+fh2,"%.8X",BufferSrc[j] );
	

		m_strRichEdit0 = chTab;
	UpdateData(FALSE);

	return;
}

void CManfGUIDlg::OnTditospecsButton() 
{
	int i=0, j=0, k=0, fh2=0, Taille, tailleBufTdi;
	char chTab[2048];
	char chTab1[80];
	unsigned char BufTdi[50];

	UpdateData(TRUE);


	while (fh2 < 50)
	{
		BufTdi[fh2] = NULL;
		fh2++ ;
	}

	fh2 = 0;
	while (fh2 < 2048)
	{
		chTab[fh2] = NULL;
		fh2++ ;
	}

	fh2 = 0;
	while (fh2 < 80)
	{
		chTab1[fh2] = NULL;
		fh2++ ;
	}

	fh2 = 0;
	while (fh2 < 256)
	{
		BufferSrc[fh2] = 0;
		fh2++ ;
	}



	sprintf(chTab,m_strJtagEdit);

	while (chTab[i] != NULL && chTab[i] != '\r')
	{
		while (chTab[i] != '\n' && chTab[i] != NULL)
		{
			chTab1[j] = chTab[i];
			i++;
			j++;
		}

		sscanf(chTab1, "%x", &BufTdi[k]);
		j=0;
		i++;
		k++;
	}
		tailleBufTdi = k;

		m_NombrelmotsEdit = TditoSpecs(BufTdi,BufferSrc,tailleBufTdi);

		BufferSrc[1] = BufferSrc[1] | (tailleBufTdi) << 8;
		BufferSrc[1] = BufferSrc[1] | modJTAG;
		Taille = m_NombrelmotsEdit;
		j = 0;
		fh2 = 0;
		while ( j < Taille-1 )
		{
			fh2 +=sprintf( chTab+fh2,"%.8X\r\n",BufferSrc[j] );
			j++;
		}
		fh2 +=sprintf( chTab+fh2,"%.8X",BufferSrc[j] );

		m_strRichEdit0 = chTab;

	UpdateData(FALSE);
}

void CManfGUIDlg::OnTdiwriteButton() 
{
	U32 i=0, j=0, k=0, fh2=0, Taille, tailleBTdiWrite;
	char chTab[2048];
	char chTab1[80];
	unsigned char BufTdi[50];
	unsigned char *pBTdiWrite;

	UpdateData(TRUE);


	while (fh2 < 50)
	{
		BufTdi[fh2] = NULL;
		fh2++ ;
	}

	fh2 = 0;
	while (fh2 < 2048)
	{
		chTab[fh2] = NULL;
		fh2++ ;
	}

	fh2 = 0;
	while (fh2 < 80)
	{
		chTab1[fh2] = NULL;
		fh2++ ;
	}

	fh2 = 0;
	while (fh2 < 256)
	{
		BufferSrc[fh2] = 0;
		fh2++ ;
	}



	sprintf(chTab,m_strJtagEdit);

	while (chTab[i] != NULL && chTab[i] != '\r')
	{
		while (chTab[i] != '\n' && chTab[i] != NULL)
		{
			chTab1[j] = chTab[i];
			i++;
			j++;
		}

		sscanf(chTab1, "%x", &BufTdi[k]);
		j=0;
		i++;
		k++;
	}
	tailleBTdiWrite = k;
	pBTdiWrite = &BufTdi[0];

	pSlv1->pSpecsmaster = &pSpm1[Index];
	pSlv1->SpecsslaveAdd = 0x00;

	JtagBufTDIWrite(pSlv1,0x00,pBTdiWrite,tailleBTdiWrite);

//	BufTdi[0] = 0x40 << 1 & 0xFE;

		m_NombrelmotsEdit = TditoSpecs(BufTdi,BufferSrc,tailleBTdiWrite);

		BufferSrc[1] = BufferSrc[1] | (tailleBTdiWrite) << 8;
		BufferSrc[1] = BufferSrc[1] | modJTAG;
		Taille = m_NombrelmotsEdit;
		j = 0;
		fh2 = 0;
		while ( j < Taille-1 )
		{
			fh2 +=sprintf( chTab+fh2,"%.8X\r\n",BufferSrc[j] );
			j++;
		}
		fh2 +=sprintf( chTab+fh2,"%.8X",BufferSrc[j] );
	

		m_strRichEdit0 = chTab;
	UpdateData(FALSE);

	return;	
}

void CManfGUIDlg::OnTmstospecsButton() 
{
	int i=0, j=0, k=0, fh2=0, Taille, tailleBufTms;
	char chTab[2048];
	char chTab1[80];
	unsigned char BufTms[50];

	UpdateData(TRUE);


	while (fh2 < 50)
	{
		BufTms[fh2] = NULL;
		fh2++ ;
	}

	fh2 = 0;
	while (fh2 < 2048)
	{
		chTab[fh2] = NULL;
		fh2++ ;
	}

	fh2 = 0;
	while (fh2 < 80)
	{
		chTab1[fh2] = NULL;
		fh2++ ;
	}

	fh2 = 0;
	while (fh2 < 256)
	{
		BufferSrc[fh2] = 0;
		fh2++ ;
	}



	sprintf(chTab,m_strJtagEdit);

	while (chTab[i] != NULL && chTab[i] != '\r')
	{
		while (chTab[i] != '\n' && chTab[i] != NULL)
		{
			chTab1[j] = chTab[i];
			i++;
			j++;
		}

		sscanf(chTab1, "%x", &BufTms[k]);
		j=0;
		i++;
		k++;
	}
		tailleBufTms = k;

		m_NombrelmotsEdit = TmstoSpecs(BufTms,BufferSrc,tailleBufTms);

		BufferSrc[1] = BufferSrc[1] | (tailleBufTms) << 8;
		BufferSrc[1] = BufferSrc[1] | modJTAG;
		Taille = m_NombrelmotsEdit;
		j = 0;
		fh2 = 0;
		while ( j < Taille-1 )
		{
			fh2 +=sprintf( chTab+fh2,"%.8X\r\n",BufferSrc[j] );
			j++;
		}
		fh2 +=sprintf( chTab+fh2,"%.8X",BufferSrc[j] );

		m_strRichEdit0 = chTab;

	UpdateData(FALSE);	
}

void CManfGUIDlg::OnTmswriteButton() 
{
	U32 i=0, j=0, k=0, fh2=0, Taille, tailleBTmsWrite;
	char chTab[2048];
	char chTab1[80];
	unsigned char BufTms[50];
	unsigned char *pBTmsWrite;

	UpdateData(TRUE);


	while (fh2 < 50)
	{
		BufTms[fh2] = NULL;
		fh2++ ;
	}

	fh2 = 0;
	while (fh2 < 2048)
	{
		chTab[fh2] = NULL;
		fh2++ ;
	}

	fh2 = 0;
	while (fh2 < 80)
	{
		chTab1[fh2] = NULL;
		fh2++ ;
	}

	fh2 = 0;
	while (fh2 < 256)
	{
		BufferSrc[fh2] = 0;
		fh2++ ;
	}



	sprintf(chTab,m_strJtagEdit);

	while (chTab[i] != NULL && chTab[i] != '\r')
	{
		while (chTab[i] != '\n' && chTab[i] != NULL)
		{
			chTab1[j] = chTab[i];
			i++;
			j++;
		}

		sscanf(chTab1, "%x", &BufTms[k]);
		j=0;
		i++;
		k++;
	}
	tailleBTmsWrite = k;
	pBTmsWrite = &BufTms[0];

	pSlv1->pSpecsmaster = &pSpm1[Index];
	pSlv1->SpecsslaveAdd = 0x00;

	JtagBufTMSWrite(pSlv1,0x00,pBTmsWrite,tailleBTmsWrite);

//	BufTms[0] = 0x40 << 1 & 0xFE;

		m_NombrelmotsEdit = TmstoSpecs(BufTms,BufferSrc,tailleBTmsWrite);

		BufferSrc[1] = BufferSrc[1] | (tailleBTmsWrite) << 8;
		BufferSrc[1] = BufferSrc[1] | modJTAG;
		Taille = m_NombrelmotsEdit;
		j = 0;
		fh2 = 0;
		while ( j < Taille-1 )
		{
			fh2 +=sprintf( chTab+fh2,"%.8X\r\n",BufferSrc[j] );
			j++;
		}
		fh2 +=sprintf( chTab+fh2,"%.8X",BufferSrc[j] );
	

		m_strRichEdit0 = chTab;
	UpdateData(FALSE);

	return;	
}

void CManfGUIDlg::OnChangeJtagEdit() 
{
		UpdateData(TRUE);
}

void CManfGUIDlg::OnOpenfileButton() 
{
	FILE	*stream;
	LPCTSTR  pBufTxt="Fichiers Texte : *.txt\0*.txt\0Tous : *.*\0*.*\0";
	int fh1,fh2,Taille;
	char chTab[2048];

	CFileDialog m_ldFile(TRUE);
	m_ldFile.m_ofn.lpstrFilter  = pBufTxt;
	m_ldFile.m_ofn.nFilterIndex = 1;


	if (m_ldFile.DoModal() == IDOK)
	{
		strNomDeFichier = m_ldFile.GetFileName();
		if ((stream = fopen(strNomDeFichier, "r")) == NULL )
			exit(1);
		fh1 = 0;
		while (fh1 < 0x100)
		{
			BufferSrc[fh1] = 0;
			fh1++;
		}
		fh1 = 0;
		while ((fscanf(stream, "%x", &BufferSrc[fh1])) != EOF)
		{
			fh1++;
		}
		if (fclose(stream))
			exit(1);
		Taille = fh1;
		m_NombrelmotsEdit = Taille;
		fh1 = 0;
		fh2 = 0;
		while (fh1 < Taille)
		{
			fh2 +=sprintf(chTab+fh2,"%.8X\r\n",BufferSrc[fh1]);
			fh1++;
		}
		m_strRichEdit0 = chTab;

	}


	UpdateData(FALSE);
}

void CManfGUIDlg::OnSavefileButton() 
{
	FILE	*stream;
	LPCTSTR  pBufTxt="Fichiers Texte : *.txt\0*.txt\0Tous : *.*\0*.*\0";
	int fh1,Taille;


	CFileDialog m_ldFile(FALSE);
	m_ldFile.m_ofn.lpstrFilter  = pBufTxt;
	m_ldFile.m_ofn.nFilterIndex = 1;

	if (m_ldFile.DoModal() == IDOK)
	{
		strNomDeFichier = m_ldFile.GetFileName();
		if ((stream = fopen(strNomDeFichier, "w")) == NULL )
			exit(1);
		Taille = m_NombrelmotsEdit;
		fh1 = 0;
		while (fh1<Taille)
		{
			fprintf(stream, "%.8X\n", BufferSrc[fh1]);
			fh1++;
		}
		if (fclose(stream))
			exit(1);

	}
}

void CManfGUIDlg::OnChangeParallelwriteEdit() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	
	UpdateData(TRUE);
}

void CManfGUIDlg::OnParallelwriteButton() 
{
	// TODO: Add your control notification handler code here
	
	U16 MotParallel=0;
	U32 fh2=0,j=0;
	U8 LocAdd;
	char chTab[2048];

	while (fh2 < 256)
	{
		BufferSrc[fh2] = 0;
		fh2++ ;
	}

	fh2 = 0;
	while (fh2 < 2048)
	{
		chTab[fh2] = NULL;
		fh2++ ;
	}

	pSlv1->pSpecsmaster = &pSpm1[Index];
	pSlv1->SpecsslaveAdd = 0x00;
	LocAdd = 0x00;

	sscanf(m_strParallelData, "%x", &MotParallel);
	ParallelWrite(pSlv1,LocAdd,MotParallel);

	BufferSrc[0] = 0x76543210;
	BufferSrc[1] = 0x4020000;
	BufferSrc[1] = BufferSrc[1] | pSlv1->SpecsslaveAdd << 18;
	BufferSrc[1] = BufferSrc[1] | LocAdd << 8;
//	BufferSrc[1] = ;
//	BufferSrc[1] = ;
	BufferSrc[2] = MotParallel;

	j = 0;
	fh2 = 0;
	while ( j < 2 )
	{
		fh2 +=sprintf( chTab+fh2,"%.8X\r\n",BufferSrc[j] );
		j++;
	}
	fh2 +=sprintf( chTab+fh2,"%.8X",BufferSrc[j] );

	m_strRichEdit0 = chTab;
	m_NombrelmotsEdit = 3;

	UpdateData(FALSE);
	return;
}

void CManfGUIDlg::OnW0Button() 
{
	// TODO: Add your control notification handler code here

	U16 MotParallel=0;
	U32 fh2=0,j=0;
	U8 LocAdd=0;
	char chTab[2048];

	while (fh2 < 256)
	{
		BufferSrc[fh2] = 0;
		fh2++ ;
	}

	fh2 = 0;
	while (fh2 < 2048)
	{
		chTab[fh2] = NULL;
		fh2++ ;
	}

	pSlv1->pSpecsmaster = &pSpm1[Index];
	pSlv1->SpecsslaveAdd = 0x00;

	sscanf(m_strParallelData, "%x", &MotParallel);
	RegisterWrite(pSlv1,LocAdd,MotParallel);

	BufferSrc[0] = 0x76543210;
	BufferSrc[1] = 0x4030000;
	BufferSrc[1] = BufferSrc[1] | pSlv1->SpecsslaveAdd << 18;
	BufferSrc[1] = BufferSrc[1] | LocAdd << 8;
//	BufferSrc[1] = ;
//	BufferSrc[1] = ;
	BufferSrc[2] = MotParallel;

	j = 0;
	fh2 = 0;
	while ( j < 2 )
	{
		fh2 +=sprintf( chTab+fh2,"%.8X\r\n",BufferSrc[j] );
		j++;
	}
	fh2 +=sprintf( chTab+fh2,"%.8X",BufferSrc[j] );

	m_strRichEdit0 = chTab;
	m_NombrelmotsEdit = 3;

	UpdateData(FALSE);
	return;	
}

void CManfGUIDlg::OnW1Button() 
{
	// TODO: Add your control notification handler code here
	
	U16 MotParallel=0;
	U32 fh2=0,j=0;
	U8 LocAdd=1;
	char chTab[2048];

	while (fh2 < 256)
	{
		BufferSrc[fh2] = 0;
		fh2++ ;
	}

	fh2 = 0;
	while (fh2 < 2048)
	{
		chTab[fh2] = NULL;
		fh2++ ;
	}

	pSlv1->pSpecsmaster = &pSpm1[Index];
	pSlv1->SpecsslaveAdd = 0x00;

	sscanf(m_strParallelData, "%x", &MotParallel);
	RegisterWrite(pSlv1,LocAdd,MotParallel);

	BufferSrc[0] = 0x76543210;
	BufferSrc[1] = 0x4030000;
	BufferSrc[1] = BufferSrc[1] | pSlv1->SpecsslaveAdd << 18;
	BufferSrc[1] = BufferSrc[1] | LocAdd << 8;
//	BufferSrc[1] = ;
//	BufferSrc[1] = ;
	BufferSrc[2] = MotParallel;

	j = 0;
	fh2 = 0;
	while ( j < 2 )
	{
		fh2 +=sprintf( chTab+fh2,"%.8X\r\n",BufferSrc[j] );
		j++;
	}
	fh2 +=sprintf( chTab+fh2,"%.8X",BufferSrc[j] );

	m_strRichEdit0 = chTab;
	m_NombrelmotsEdit = 3;

	UpdateData(FALSE);
	return;
}

void CManfGUIDlg::OnW2Button() 
{
	// TODO: Add your control notification handler code here
	
	U16 MotParallel=0;
	U32 fh2=0,j=0;
	U8 LocAdd=2;
	char chTab[2048];

	while (fh2 < 256)
	{
		BufferSrc[fh2] = 0;
		fh2++ ;
	}

	fh2 = 0;
	while (fh2 < 2048)
	{
		chTab[fh2] = NULL;
		fh2++ ;
	}

	pSlv1->pSpecsmaster = &pSpm1[Index];
	pSlv1->SpecsslaveAdd = 0x00;

	sscanf(m_strParallelData, "%x", &MotParallel);
	RegisterWrite(pSlv1,LocAdd,MotParallel);

	BufferSrc[0] = 0x76543210;
	BufferSrc[1] = 0x4030000;
	BufferSrc[1] = BufferSrc[1] | pSlv1->SpecsslaveAdd << 18;
	BufferSrc[1] = BufferSrc[1] | LocAdd << 8;
//	BufferSrc[1] = ;
//	BufferSrc[1] = ;
	BufferSrc[2] = MotParallel;

	j = 0;
	fh2 = 0;
	while ( j < 2 )
	{
		fh2 +=sprintf( chTab+fh2,"%.8X\r\n",BufferSrc[j] );
		j++;
	}
	fh2 +=sprintf( chTab+fh2,"%.8X",BufferSrc[j] );

	m_strRichEdit0 = chTab;
	m_NombrelmotsEdit = 3;

	UpdateData(FALSE);
	return;
}

void CManfGUIDlg::OnW3Button() 
{
	// TODO: Add your control notification handler code here

	U16 MotParallel=0;
	U32 fh2=0,j=0;
	U8 LocAdd=3;
	char chTab[2048];

	while (fh2 < 256)
	{
		BufferSrc[fh2] = 0;
		fh2++ ;
	}

	fh2 = 0;
	while (fh2 < 2048)
	{
		chTab[fh2] = NULL;
		fh2++ ;
	}

	pSlv1->pSpecsmaster = &pSpm1[Index];
	pSlv1->SpecsslaveAdd = 0x00;

	sscanf(m_strParallelData, "%x", &MotParallel);
	RegisterWrite(pSlv1,LocAdd,MotParallel);

	BufferSrc[0] = 0x76543210;
	BufferSrc[1] = 0x4030000;
	BufferSrc[1] = BufferSrc[1] | pSlv1->SpecsslaveAdd << 18;
	BufferSrc[1] = BufferSrc[1] | LocAdd << 8;
//	BufferSrc[1] = ;
//	BufferSrc[1] = ;
	BufferSrc[2] = MotParallel;

	j = 0;
	fh2 = 0;
	while ( j < 2 )
	{
		fh2 +=sprintf( chTab+fh2,"%.8X\r\n",BufferSrc[j] );
		j++;
	}
	fh2 +=sprintf( chTab+fh2,"%.8X",BufferSrc[j] );

	m_strRichEdit0 = chTab;
	m_NombrelmotsEdit = 3;

	UpdateData(FALSE);
	return;
}

void CManfGUIDlg::OnW4Button() 
{
	// TODO: Add your control notification handler code here

	U16 MotParallel=0;
	U32 fh2=0,j=0;
	U8 LocAdd=4;
	char chTab[2048];

	while (fh2 < 256)
	{
		BufferSrc[fh2] = 0;
		fh2++ ;
	}

	fh2 = 0;
	while (fh2 < 2048)
	{
		chTab[fh2] = NULL;
		fh2++ ;
	}

	pSlv1->pSpecsmaster = &pSpm1[Index];
	pSlv1->SpecsslaveAdd = 0x00;

	sscanf(m_strParallelData, "%x", &MotParallel);
	RegisterWrite(pSlv1,LocAdd,MotParallel);

	BufferSrc[0] = 0x76543210;
	BufferSrc[1] = 0x4030000;
	BufferSrc[1] = BufferSrc[1] | pSlv1->SpecsslaveAdd << 18;
	BufferSrc[1] = BufferSrc[1] | LocAdd << 8;
//	BufferSrc[1] = ;
//	BufferSrc[1] = ;
	BufferSrc[2] = MotParallel;

	j = 0;
	fh2 = 0;
	while ( j < 2 )
	{
		fh2 +=sprintf( chTab+fh2,"%.8X\r\n",BufferSrc[j] );
		j++;
	}
	fh2 +=sprintf( chTab+fh2,"%.8X",BufferSrc[j] );

	m_strRichEdit0 = chTab;
	m_NombrelmotsEdit = 3;

	UpdateData(FALSE);
	return;
}

void CManfGUIDlg::OnW5Button() 
{
	// TODO: Add your control notification handler code here

	U16 MotParallel=0;
	U32 fh2=0,j=0;
	U8 LocAdd=5;
	char chTab[2048];

	while (fh2 < 256)
	{
		BufferSrc[fh2] = 0;
		fh2++ ;
	}

	fh2 = 0;
	while (fh2 < 2048)
	{
		chTab[fh2] = NULL;
		fh2++ ;
	}

	pSlv1->pSpecsmaster = &pSpm1[Index];
	pSlv1->SpecsslaveAdd = 0x00;

	sscanf(m_strParallelData, "%x", &MotParallel);
	RegisterWrite(pSlv1,LocAdd,MotParallel);

	BufferSrc[0] = 0x76543210;
	BufferSrc[1] = 0x4030000;
	BufferSrc[1] = BufferSrc[1] | pSlv1->SpecsslaveAdd << 18;
	BufferSrc[1] = BufferSrc[1] | LocAdd << 8;
//	BufferSrc[1] = ;
//	BufferSrc[1] = ;
	BufferSrc[2] = MotParallel;

	j = 0;
	fh2 = 0;
	while ( j < 2 )
	{
		fh2 +=sprintf( chTab+fh2,"%.8X\r\n",BufferSrc[j] );
		j++;
	}
	fh2 +=sprintf( chTab+fh2,"%.8X",BufferSrc[j] );

	m_strRichEdit0 = chTab;
	m_NombrelmotsEdit = 3;

	UpdateData(FALSE);
	return;
}

void CManfGUIDlg::OnParallelreadButton() 
{
	// TODO: Add your control notification handler code here

	U16 MotParallel=0;
	U32 fh2=0,j=0;
	U8 LocAdd;
	U32 BufferDest[3];
	char chTab[2048];

	while (fh2 < 256)
	{
		BufferSrc[fh2] = 0;
		fh2++ ;
	}

	fh2 = 0;
	while (fh2 < 2048)
	{
		chTab[fh2] = NULL;
		fh2++ ;
	}

	pSlv1->pSpecsmaster = &pSpm1[Index];
	pSlv1->SpecsslaveAdd = 0x00;
	LocAdd = 0x00;

//	sscanf(m_strParallelData, "%x", &MotParallel);
	ParallelRead(pSlv1,LocAdd,&MotParallel);

	SpecsmasterReceiverFIFORead(&pSpm1[Index], BufferDest, 3);

	BufferSrc[0] = 0x76543210;
	BufferSrc[1] = 0x4020000;
	BufferSrc[1] = BufferSrc[1] | pSlv1->SpecsslaveAdd << 18;
	BufferSrc[1] = BufferSrc[1] | LocAdd << 8;
	BufferSrc[1] = BufferSrc[1] | 1;
//	BufferSrc[1] = ;
//	BufferSrc[2] = MotParallel;

	j = 0;
	fh2 = 0;
	while ( j < 2 )
	{
		fh2 +=sprintf( chTab+fh2,"%.8X\r\n",BufferSrc[j] );
		j++;
	}
	fh2 +=sprintf( chTab+fh2,"%.8X",BufferSrc[j] );

	m_strRichEdit0 = chTab;
	m_NombrelmotsEdit = 3;

	fh2 = 0;
	while (fh2 < 2048)
	{
		chTab[fh2] = NULL;
		fh2++ ;
	}

	fh2 = 0;
	j = 0;
	while (j < 3)
	{
		fh2 += sprintf(chTab + fh2, "%.8X\r\n", BufferDest[j]);
		j++;
	}

	m_strLectfifoEdit = chTab;

	UpdateData(FALSE);
	return;
	
}

void CManfGUIDlg::OnR0Button() 
{
	// TODO: Add your control notification handler code here

	U16 MotParallel=0;
	U32 fh2=0,j=0;
	U8 LocAdd=0;
	U32 BufferDest[3];
	char chTab[2048];

	while (fh2 < 256)
	{
		BufferSrc[fh2] = 0;
		fh2++ ;
	}

	fh2 = 0;
	while (fh2 < 2048)
	{
		chTab[fh2] = NULL;
		fh2++ ;
	}

	pSlv1->pSpecsmaster = &pSpm1[Index];
	pSlv1->SpecsslaveAdd = 0x00;

//	sscanf(m_strParallelData, "%x", &MotParallel);
	ParallelRead(pSlv1,LocAdd,&MotParallel);

	SpecsmasterReceiverFIFORead(&pSpm1[Index], BufferDest, 3);

	BufferSrc[0] = 0x76543210;
	BufferSrc[1] = 0x4030000;
	BufferSrc[1] = BufferSrc[1] | pSlv1->SpecsslaveAdd << 18;
	BufferSrc[1] = BufferSrc[1] | LocAdd << 8;
	BufferSrc[1] = BufferSrc[1] | 1;
//	BufferSrc[1] = ;
//	BufferSrc[2] = MotParallel;

	j = 0;
	fh2 = 0;
	while ( j < 2 )
	{
		fh2 +=sprintf( chTab+fh2,"%.8X\r\n",BufferSrc[j] );
		j++;
	}
	fh2 +=sprintf( chTab+fh2,"%.8X",BufferSrc[j] );

	m_strRichEdit0 = chTab;
	m_NombrelmotsEdit = 3;

	fh2 = 0;
	while (fh2 < 2048)
	{
		chTab[fh2] = NULL;
		fh2++ ;
	}

	fh2 = 0;
	j = 0;
	while (j < 3)
	{
		fh2 += sprintf(chTab + fh2, "%.8X\r\n", BufferDest[j]);
		j++;
	}

	m_strLectfifoEdit = chTab;

	UpdateData(FALSE);
	return;
	
}

void CManfGUIDlg::OnR1Button() 
{
	// TODO: Add your control notification handler code here
	
	U16 MotParallel=0;
	U32 fh2=0,j=0;
	U8 LocAdd=1;
	U32 BufferDest[3];
	char chTab[2048];

	while (fh2 < 256)
	{
		BufferSrc[fh2] = 0;
		fh2++ ;
	}

	fh2 = 0;
	while (fh2 < 2048)
	{
		chTab[fh2] = NULL;
		fh2++ ;
	}

	pSlv1->pSpecsmaster = &pSpm1[Index];
	pSlv1->SpecsslaveAdd = 0x00;

//	sscanf(m_strParallelData, "%x", &MotParallel);
	ParallelRead(pSlv1,LocAdd,&MotParallel);

	SpecsmasterReceiverFIFORead(&pSpm1[Index], BufferDest, 3);

	BufferSrc[0] = 0x76543210;
	BufferSrc[1] = 0x4030000;
	BufferSrc[1] = BufferSrc[1] | pSlv1->SpecsslaveAdd << 18;
	BufferSrc[1] = BufferSrc[1] | LocAdd << 8;
	BufferSrc[1] = BufferSrc[1] | 1;
//	BufferSrc[1] = ;
//	BufferSrc[2] = MotParallel;

	j = 0;
	fh2 = 0;
	while ( j < 2 )
	{
		fh2 +=sprintf( chTab+fh2,"%.8X\r\n",BufferSrc[j] );
		j++;
	}
	fh2 +=sprintf( chTab+fh2,"%.8X",BufferSrc[j] );

	m_strRichEdit0 = chTab;
	m_NombrelmotsEdit = 3;

	fh2 = 0;
	while (fh2 < 2048)
	{
		chTab[fh2] = NULL;
		fh2++ ;
	}

	fh2 = 0;
	j = 0;
	while (j < 3)
	{
		fh2 += sprintf(chTab + fh2, "%.8X\r\n", BufferDest[j]);
		j++;
	}

	m_strLectfifoEdit = chTab;

	UpdateData(FALSE);
	return;
}

void CManfGUIDlg::OnR2Button() 
{
	// TODO: Add your control notification handler code here
	
	U16 MotParallel=0;
	U32 fh2=0,j=0;
	U8 LocAdd=2;
	U32 BufferDest[3];
	char chTab[2048];

	while (fh2 < 256)
	{
		BufferSrc[fh2] = 0;
		fh2++ ;
	}

	fh2 = 0;
	while (fh2 < 2048)
	{
		chTab[fh2] = NULL;
		fh2++ ;
	}

	pSlv1->pSpecsmaster = &pSpm1[Index];
	pSlv1->SpecsslaveAdd = 0x00;

//	sscanf(m_strParallelData, "%x", &MotParallel);
	ParallelRead(pSlv1,LocAdd,&MotParallel);

	SpecsmasterReceiverFIFORead(&pSpm1[Index], BufferDest, 3);

	BufferSrc[0] = 0x76543210;
	BufferSrc[1] = 0x4030000;
	BufferSrc[1] = BufferSrc[1] | pSlv1->SpecsslaveAdd << 18;
	BufferSrc[1] = BufferSrc[1] | LocAdd << 8;
	BufferSrc[1] = BufferSrc[1] | 1;
//	BufferSrc[1] = ;
//	BufferSrc[2] = MotParallel;

	j = 0;
	fh2 = 0;
	while ( j < 2 )
	{
		fh2 +=sprintf( chTab+fh2,"%.8X\r\n",BufferSrc[j] );
		j++;
	}
	fh2 +=sprintf( chTab+fh2,"%.8X",BufferSrc[j] );

	m_strRichEdit0 = chTab;
	m_NombrelmotsEdit = 3;

	fh2 = 0;
	while (fh2 < 2048)
	{
		chTab[fh2] = NULL;
		fh2++ ;
	}

	fh2 = 0;
	j = 0;
	while (j < 3)
	{
		fh2 += sprintf(chTab + fh2, "%.8X\r\n", BufferDest[j]);
		j++;
	}

	m_strLectfifoEdit = chTab;

	UpdateData(FALSE);
	return;
}

void CManfGUIDlg::OnR3Button() 
{
	// TODO: Add your control notification handler code here
	
	U16 MotParallel=0;
	U32 fh2=0,j=0;
	U8 LocAdd=3;
	U32 BufferDest[3];
	char chTab[2048];

	while (fh2 < 256)
	{
		BufferSrc[fh2] = 0;
		fh2++ ;
	}

	fh2 = 0;
	while (fh2 < 2048)
	{
		chTab[fh2] = NULL;
		fh2++ ;
	}

	pSlv1->pSpecsmaster = &pSpm1[Index];
	pSlv1->SpecsslaveAdd = 0x00;

//	sscanf(m_strParallelData, "%x", &MotParallel);
	ParallelRead(pSlv1,LocAdd,&MotParallel);

	SpecsmasterReceiverFIFORead(&pSpm1[Index], BufferDest, 3);

	BufferSrc[0] = 0x76543210;
	BufferSrc[1] = 0x4030000;
	BufferSrc[1] = BufferSrc[1] | pSlv1->SpecsslaveAdd << 18;
	BufferSrc[1] = BufferSrc[1] | LocAdd << 8;
	BufferSrc[1] = BufferSrc[1] | 1;
//	BufferSrc[1] = ;
//	BufferSrc[2] = MotParallel;

	j = 0;
	fh2 = 0;
	while ( j < 2 )
	{
		fh2 +=sprintf( chTab+fh2,"%.8X\r\n",BufferSrc[j] );
		j++;
	}
	fh2 +=sprintf( chTab+fh2,"%.8X",BufferSrc[j] );

	m_strRichEdit0 = chTab;
	m_NombrelmotsEdit = 3;

	fh2 = 0;
	while (fh2 < 2048)
	{
		chTab[fh2] = NULL;
		fh2++ ;
	}

	fh2 = 0;
	j = 0;
	while (j < 3)
	{
		fh2 += sprintf(chTab + fh2, "%.8X\r\n", BufferDest[j]);
		j++;
	}

	m_strLectfifoEdit = chTab;

	UpdateData(FALSE);
	return;
}

void CManfGUIDlg::OnR4Button() 
{
	// TODO: Add your control notification handler code here
	
	U16 MotParallel=0;
	U32 fh2=0,j=0;
	U8 LocAdd=4;
	U32 BufferDest[3];
	char chTab[2048];

	while (fh2 < 256)
	{
		BufferSrc[fh2] = 0;
		fh2++ ;
	}

	fh2 = 0;
	while (fh2 < 2048)
	{
		chTab[fh2] = NULL;
		fh2++ ;
	}

	pSlv1->pSpecsmaster = &pSpm1[Index];
	pSlv1->SpecsslaveAdd = 0x00;

//	sscanf(m_strParallelData, "%x", &MotParallel);
	ParallelRead(pSlv1,LocAdd,&MotParallel);

	SpecsmasterReceiverFIFORead(&pSpm1[Index], BufferDest, 3);

	BufferSrc[0] = 0x76543210;
	BufferSrc[1] = 0x4030000;
	BufferSrc[1] = BufferSrc[1] | pSlv1->SpecsslaveAdd << 18;
	BufferSrc[1] = BufferSrc[1] | LocAdd << 8;
	BufferSrc[1] = BufferSrc[1] | 1;
//	BufferSrc[1] = ;
//	BufferSrc[2] = MotParallel;

	j = 0;
	fh2 = 0;
	while ( j < 2 )
	{
		fh2 +=sprintf( chTab+fh2,"%.8X\r\n",BufferSrc[j] );
		j++;
	}
	fh2 +=sprintf( chTab+fh2,"%.8X",BufferSrc[j] );

	m_strRichEdit0 = chTab;
	m_NombrelmotsEdit = 3;

	fh2 = 0;
	while (fh2 < 2048)
	{
		chTab[fh2] = NULL;
		fh2++ ;
	}

	fh2 = 0;
	j = 0;
	while (j < 3)
	{
		fh2 += sprintf(chTab + fh2, "%.8X\r\n", BufferDest[j]);
		j++;
	}

	m_strLectfifoEdit = chTab;

	UpdateData(FALSE);
	return;
}

void CManfGUIDlg::OnR5Button() 
{
	// TODO: Add your control notification handler code here
	
	U16 MotParallel=0;
	U32 fh2=0,j=0;
	U8 LocAdd=5;
	U32 BufferDest[3];
	char chTab[2048];

	while (fh2 < 256)
	{
		BufferSrc[fh2] = 0;
		fh2++ ;
	}

	fh2 = 0;
	while (fh2 < 2048)
	{
		chTab[fh2] = NULL;
		fh2++ ;
	}

	pSlv1->pSpecsmaster = &pSpm1[Index];
	pSlv1->SpecsslaveAdd = 0x00;

//	sscanf(m_strParallelData, "%x", &MotParallel);
	ParallelRead(pSlv1,LocAdd,&MotParallel);

	SpecsmasterReceiverFIFORead(&pSpm1[Index], BufferDest, 3);

	BufferSrc[0] = 0x76543210;
	BufferSrc[1] = 0x4030000;
	BufferSrc[1] = BufferSrc[1] | pSlv1->SpecsslaveAdd << 18;
	BufferSrc[1] = BufferSrc[1] | LocAdd << 8;
	BufferSrc[1] = BufferSrc[1] | 1;
//	BufferSrc[1] = ;
//	BufferSrc[2] = MotParallel;

	j = 0;
	fh2 = 0;
	while ( j < 2 )
	{
		fh2 +=sprintf( chTab+fh2,"%.8X\r\n",BufferSrc[j] );
		j++;
	}
	fh2 +=sprintf( chTab+fh2,"%.8X",BufferSrc[j] );

	m_strRichEdit0 = chTab;
	m_NombrelmotsEdit = 3;

	fh2 = 0;
	while (fh2 < 2048)
	{
		chTab[fh2] = NULL;
		fh2++ ;
	}

	fh2 = 0;
	j = 0;
	while (j < 3)
	{
		fh2 += sprintf(chTab + fh2, "%.8X\r\n", BufferDest[j]);
		j++;
	}

	m_strLectfifoEdit = chTab;

	UpdateData(FALSE);
	return;
}
